/*
	Preparation Date : 2014-09-24
	Preparation By   : Rahmat
	Description      : Get data for download detail grid
*/

CREATE PROCEDURE [dbo].[SP_DLV_INV_getCreationDetailGridDownload]
   @DLV_NO varchar(max),
   @LP_INV_NO varchar(max)
AS
BEGIN	
	--DECLARE @DLV_NO as varchar(max) = 'R201402188851,R201402189231'
	DECLARE @x XML;
	DECLARE @y XML;
	SET @x = '<r>' + REPLACE((SELECT @DLV_NO FOR XML PATH('')), ',', '</r><r>') + '</r>';
	SET @y = '<r>' + REPLACE((SELECT @LP_INV_NO FOR XML PATH('')), ',', '</r><r>') + '</r>';

	IF (@LP_INV_NO != '')
	BEGIN
		SELECT * FROM (
			SELECT DISTINCT 
				a.REFF_NO 
				+'|'+ 
				(CASE WHEN CONVERT ( VARCHAR (MAX), a.PO_DETAIL_PRICE ) != '' THEN CONVERT ( VARCHAR (MAX), a.PO_DETAIL_PRICE ) ELSE '' END)
				+'|'+ 
				(CASE WHEN CONVERT ( VARCHAR (MAX), a.PO_NO ) != '' THEN CONVERT ( VARCHAR (MAX), a.PO_NO) ELSE '' END)
				+'|'+ 
				(CASE WHEN CONVERT ( VARCHAR (MAX), b.LP_INV_NO ) != '' THEN CONVERT ( VARCHAR (MAX), b.LP_INV_NO) ELSE '' END)
				
				AS DATA_KEY,
				a.REFF_NO,
				CS.COMP_PRICE_TEXT,
				a.GR_IR_AMT as VALUE,
				(a.GR_IR_AMT * c.TRANSACTION_QTY) as AMOUNT,
				a.PO_NO,
				c.TRANSACTION_QTY,
				a.SERVICE_DOC_NO,
				a.ITEM_NO,
				a.COMP_PRICE_CD,
				b.LP_INV_NO,
				a.PO_ITEM_NO
			FROM TB_R_DLV_GR_IR a
				LEFT JOIN TB_R_DLV_INV_UPLOAD b ON b.PO_NO = a.PO_NO AND b.DELIVERY_NO = a.REFF_NO AND b.STATUS_CD = a.STATUS_CD
					AND b.COMP_PRICE_CD = a.COMP_PRICE_CD
				LEFT JOIN TB_R_DLV_SERVICE_DOC c ON c.SERVICE_DOC_NO = a.SERVICE_DOC_NO
				LEFT JOIN TB_M_LOGISTIC_PARTNER LP ON LP.LOG_PARTNER_CD = c.LP_CD
				LEFT JOIN TB_M_CALC_SCHEME CS ON CS.COMP_PRICE_CD = a.COMP_PRICE_CD
			WHERE 1=1 AND a.CANCEL_STS IS NULL AND a.CONDITION_CATEGORY = 'H' AND a.STATUS_CD IN ('1', '-1')
				AND a.CONDITION_CATEGORY = 'H'
		) TBL
		WHERE 
			REFF_NO IN (SELECT  y.XmlCol.value('(text())[1]', 'VARCHAR(MAX)') AS Value FROM @x.nodes('/r') y(XmlCol)) 
			AND
			LP_INV_NO IN (SELECT  y.XmlCol.value('(text())[1]', 'VARCHAR(MAX)') AS Value FROM @y.nodes('/r') y(XmlCol))
		ORDER BY LP_INV_NO, REFF_NO DESC
	END ELSE
	BEGIN
		SELECT * FROM (
			SELECT DISTINCT 
				a.REFF_NO 
				+'|'+ 
				(CASE WHEN CONVERT ( VARCHAR (MAX), a.PO_DETAIL_PRICE ) != '' THEN CONVERT ( VARCHAR (MAX), a.PO_DETAIL_PRICE ) ELSE '' END)
				+'|'+ 
				(CASE WHEN CONVERT ( VARCHAR (MAX), a.PO_NO ) != '' THEN CONVERT ( VARCHAR (MAX), a.PO_NO) ELSE '' END)
				+'|'+ 
				(CASE WHEN CONVERT ( VARCHAR (MAX), b.LP_INV_NO ) != '' THEN CONVERT ( VARCHAR (MAX), b.LP_INV_NO) ELSE '' END)
				
				AS DATA_KEY,
				a.REFF_NO,
				CS.COMP_PRICE_TEXT,
				a.GR_IR_AMT as VALUE,
				(a.GR_IR_AMT * c.TRANSACTION_QTY) as AMOUNT,
				a.PO_NO,
				c.TRANSACTION_QTY,
				a.SERVICE_DOC_NO,
				a.ITEM_NO,
				a.COMP_PRICE_CD,
				b.LP_INV_NO,
				a.PO_ITEM_NO
			FROM TB_R_DLV_GR_IR a
				LEFT JOIN TB_R_DLV_INV_UPLOAD b ON b.PO_NO = a.PO_NO AND b.DELIVERY_NO = a.REFF_NO AND b.STATUS_CD = a.STATUS_CD
					AND b.COMP_PRICE_CD = a.COMP_PRICE_CD
				LEFT JOIN TB_R_DLV_SERVICE_DOC c ON c.SERVICE_DOC_NO = a.SERVICE_DOC_NO
				LEFT JOIN TB_M_LOGISTIC_PARTNER LP ON LP.LOG_PARTNER_CD = c.LP_CD
				LEFT JOIN TB_M_CALC_SCHEME CS ON CS.COMP_PRICE_CD = a.COMP_PRICE_CD
			WHERE 1=1 AND a.CANCEL_STS IS NULL AND a.CONDITION_CATEGORY = 'H' AND a.STATUS_CD IN ('1', '-1')
				AND a.CONDITION_CATEGORY = 'H'
		) TBL
		WHERE 
			REFF_NO IN (SELECT  y.XmlCol.value('(text())[1]', 'VARCHAR(MAX)') AS Value FROM @x.nodes('/r') y(XmlCol)) 
			AND
			LP_INV_NO IS NULL
		ORDER BY LP_INV_NO, REFF_NO DESC
	END
	
END

